import React, { Component } from 'react';
import * as echarts from 'echarts';
import dateformat from 'dateformat'
import moment from 'moment'
class App extends Component {
    state={
        data:[],
        TopAxisX:[],
        BottomAxisX:[],
        TopAxisX1:[],
        AxisY:[],
        Links:[],
        target:[],
    }
  componentDidMount(){
    fetch('/api/graph_by_height_and_duration?height=0&duration=0',{
        method:'GET',
        headers:{
            'Content-Type':'application/json;charset=UTF-8'
        },
    })
    .then(res =>
        res.json()
    )
    .then((data) => {
        this.setState({
            data:data.result.Rows,
            TopAxisX:data.result.AxisX.TopAxisX,
            BottomAxisX:data.result.AxisX.BottomAxisX,
            AxisY:data.result.AxisY,
            Links:data.result.Links,
        })

        var markline=data.result.AxisX.TopAxisX.map(item=>{
            console.log(item,'sssssssss');
            return [ 
                        {
                            // name: 'start', 
                            xAxis:item.Time, 
                            yAxis: '1',
                            label: {
                                show: true,
                                lineHeight:25,
                                // position: 'start', // 改变label位置
                                position: 'insideMiddleTop',
                                formatter:item.Value , // 格式化标签文本
                            },
                            lineStyle: { color: 'red', type: 'solid',with:30},
                        },
                        {
                            // name: 'end', 
                            xAxis: item.Time, 
                            yAxis: '1'
                        },
                    ] 
        })
        data.result.AxisX.BottomAxisX.map(item=>{
            console.log(item,'sssssssss');
            markline.push( [ 
                        {
                            // name: 'start', 
                            xAxis:item.Time, 
                            yAxis: '0',
                            label: {
                                show: true,
                                lineHeight:25,
                                // position: 'start', // 改变label位置
                                position: 'insideMiddleTop',
                                formatter:item.Value , // 格式化标签文本
                            },
                            lineStyle: { color: 'green', type: 'solid',with:30},
                        },
                        {
                            // name: 'end', 
                            xAxis: item.Time, 
                            yAxis: '0'
                        },
                    ] )
        })



        var source= data.result.Rows
        var target=[];
        for(var i in source){
            var list=[];
            var lineList=source[i];
            for (var j in lineList) {
                list.push([
                    lineList[j].XAsTime,
                    lineList[j].Type,
                    lineList[j].Y,
                    lineList[j].Desc,
                    lineList[j].Round,
                    lineList[j].Index,
                    lineList[j].ID,
                    lineList[j].Role
                ]);
            }
            target.push(list);
        }

        var chartDom = document.getElementById('main');
        var myChart = echarts.init(chartDom);
       
        var option;
        const series = [];
        this.state.AxisY.forEach(function (type) {
             const arr = target.map(function (item) {
                const data = item.map((item, index) => {
                    // console.log(item,'item')
                        var colors 
                        if(item[7]=='Normal'){
                            colors ='#4B4B4B'
                        }else if(item[7]=='Witness'){
                            colors ='#4A4CFF'
                        }else if(item[7]=='Famous1'){
                            colors ='#00FFFF'
                        }else if(item[7]=='Famous2'){
                            colors ='#06FF02'
                        }
                        
                    return {
                        label: {
                            show: true,
                            position: 'top'
                        },
                        emphasis: {
                            label: {
                                show: true,
                            }
                        },
                        name: item[6],
                        value: item,
                        // x: item[0],
                        itemStyle:{
                                borderWidth: 1,
                                borderColor: '#333',
                                color:colors,
                        },
                        symbolSize:item[3]==item[6]? 15 : 15 
                    }; 
                })
                return data;
            })
            var newArr=arr.reduce(function(total,currentValue){
                return total.concat(currentValue)
            })
            // console.log(newArr,'data')
            // let xTime = newArr.map(item=>moment(Number(item.x)).format('YYYY-MM-DD HH:mm:ss:msms'))
            // console.log(xTime)
            let links = data.result.Links;
            links.map(item=>{
                item['source'] = item['Source']
                item['target'] = item['Target']
            })
            // links.pop();
            series.push({
                name: type,
                type: 'graph',
                coordinateSystem: 'cartesian2d',
                data: newArr,
                links: links,
                edgeSymbol: ['none', 'arrow'],
                edgeSymbolSize: 5,
                legendHoverLink: false,
                lineStyle: {
                    color: '#333'
                },
                itemStyle: {
                    borderWidth: 1,
                    borderColor: '#333',
                },
                label: {
                    color: '#333',
                    position: 'center'
                },

                symbolSize: 15,
                markLine:{
                        symbol:'circle',
                        // label: {
                        //     show: true,
                        //     lineHeight:25,
                        //     // position: 'start', // 改变label位置
                        //     position: 'insideMiddleTop',
                        //     formatter:'44' , // 格式化标签文本
                        // },
                        // lineStyle: { color: 'red', type: 'solid',with:30},
                        data:markline,
                        // data:data.result.AxisX.TopAxisX.map(item=>{
                        //     console.log(item,'sssssssss');
                        //     return [ 
                        //                 {
                        //                     // name: 'start', 
                        //                     xAxis:item.Time, 
                        //                     yAxis: '1',
                        //                     label: {
                        //                         show: true,
                        //                         lineHeight:25,
                        //                         // position: 'start', // 改变label位置
                        //                         position: 'insideMiddleTop',
                        //                         formatter:item.Value , // 格式化标签文本
                        //                     },
                        //                 },
                        //                 {
                        //                     // name: 'end', 
                        //                     xAxis: item.Time, 
                        //                     yAxis: '1'
                        //                 },
                        //             ] 
                        // })





                        // data: [
                        //         [
                                    
                        //             {
                        //                 // name: 'start', 
                        //                 xAxis:1656661857445335979, 
                        //                 yAxis: '1',
                        //                 label: {
                        //                     show: true,
                        //                     lineHeight:25,
                        //                     // position: 'start', // 改变label位置
                        //                     position: 'insideMiddleTop',
                        //                     formatter:'44' , // 格式化标签文本
                        //                 },
                        //             },
                        //             {
                        //                 // name: 'end', 
                        //                 xAxis: 1656661857445335979, 
                        //                 yAxis: '1'
                        //             },
                        //         ] ,
                        //         [
                        //             {
                        //                 // name: 'start', 
                        //                 xAxis:1656661857445335979, 
                        //                 yAxis: '0',
                        //                 label: {
                        //                     show: true,
                        //                     lineHeight:25,
                        //                     // position: 'start', // 改变label位置
                        //                     position: 'insideMiddleTop',
                        //                     formatter:'33' , // 格式化标签文本
                        //                 },
                        //             },
                        //             {
                        //                 // name: 'end', 
                        //                 xAxis: 1656661857445335979, 
                        //                 yAxis: '0'
                        //             },
                        //         ]   
                        //     ]
                      }
                
                // animationDelay: function (idx) {
                //     return idx * 100;
                // }
                // markLine: {
                //     // symbol: false, // 取消箭头
                //     // symbol:'circle',
                //     silent: true,          
                    // label: {
                    //         position: 'end', // 改变label位置
                    //         formatter: obj => obj.value , // 格式化标签文本
                    //     },
                    // lineStyle: { color: 'green', type: 'dashed',},
                //     data: [1656644187565905957,1656644189069603127].map(val => {
                //         return {
                //             xAxis: val,

                //         }; 
                //     }),
                //     data: [1656644187167024789,1656644187807296860,1656644189321454152,1656644191378335729,1656644193589957040,1656644195370205531].map(val => {
                //         return {
                //             xAxis: val,

                //         }; 
                //     }),
                //     z: 10,
                // },
              
            });
            
        });
        option = {
            visualMap: {
                show: false,
                dimension: 1,
            },
            legend: {
                show: false,
                data: this.state.AxisY,
                
                selectedMode: 'single',
                right: 100
            },
            grid: {
                left: 0,
                bottom: 0,
                containLabel: true,
                top: 80
            },
            xAxis: [
                {
                    // type: 'value',
                    // type:'time',
                    axisLabel: {
                        formatter: (function(value){
                            // let statusPassTime = moment(parseInt(value)).format('YYYY-MM-DD');
                            console.log(moment(parseInt(value/1000000)).format('YYYY-MM-DD HH:mm:ss'),'moment')
                            // return moment(parseInt(value/1000000)).format('YYYY-MM-DD HH:mm:ss')
                            return moment(parseInt(value/1000000)).format('YYYY-MM-DD HH:mm:ss.SSS')
                        //     console.log(Math.floor(value/1000000000),'ddd')
                        //     console.log(dateformat(Math.floor(value/1000000000), 'yyyy-mm-dd HH:MM:ss'),'sssdddggg')
                        //     console.log(dateformat(value/1000000000, 'yyyy-mm-dd HH:MM:ss'),'dddddddddddd')
                        //    return dateformat(value/1000000000, 'yyyy-mm-dd HH:MM:ss')
                            // console.log(Math.floor(value/1000000000),'value');
                            // console.log(value,'value11');
                            // return Math.floor(value/1000000000)
                        //   let label;
                        // //   var t = Math.floor(value/1000000000);
                        // var t=parseInt(value/1000000000)
                        //     // 天    总秒数/一天的秒数=几天
                        //     var d = parseInt( t / (24*60*60) );
                        //     // 小时  不够一天的秒数可以换算成几小时
                        //     var h = parseInt( ( t % (24*60*60) ) / (60*60) );
                        //     // 分钟  不够一小时的秒数可以换算成几分钟
                        //     var m = parseInt( ( t % (60*60) ) / 60 );
                        //     //秒数	不够一分钟的秒数可以换算成几秒
                        //     var s = t % 60 ;
                        //     return d+'-'+h+':'+m+':'+s
                        })
                    },
                    min: data.result.AxisX.AxisXBegin,
                    max:data.result.AxisX.AxisXEnd,
                    interval:(data.result.AxisX.AxisXEnd-data.result.AxisX.AxisXBegin)/5,
                    // offset:-75,
                    axisLine:{
                        show:true,
                        symbol: ['none', 'arrow']
                    },
                    boundaryGap: true,
                    axisTick: { 
                        alignWithLabel:true,
                    },

                },
                
                // {
                //     // type: 'value',
                    
                //     min: data.result.AxisX.AxisXBegin,
                //     max:data.result.AxisX.AxisXEnd,
                //     interval:(data.result.AxisX.AxisXEnd-data.result.AxisX.AxisXBegin)/5,
                //     // offset:-75,
                //     axisLine:{
                //         show:true,
                //         symbol: ['none', 'arrow']
                //     },
                //     boundaryGap: true,
                //     axisTick: { 
                //         alignWithLabel:true,
                //     },

                // },
                // 上边的轴指的是之前block 
                {
                    name:'block',
                    // data:topValue,
                    // offset:-75,
                    axisLine:{
                        show: true,
                        symbol: ['none', 'arrow']
                    },
                    axisLabel:{
                        inside: false,
                    },
                    boundaryGap: true,
                    axisTick: { 
                        alignWithLabel:true,
                    }
                },
                {
                    // name:'block',
                    // data:topTime,
                    // offset:-75,
                    axisLine:{
                        show: true,
                        symbol: ['none', 'arrow']
                    },
                    axisLabel:{
                        inside: true,
                    },
                    boundaryGap: true,
                    axisTick: { 
                        alignWithLabel:true,
                    }
                },

                // // 下边的轴指的是之前的round
                // {
                //     name:'round',
                //     offset:-690,
                //     data:bottomValue,
                //     axisLine:{
                //         show: true,
                //         symbol: ['none', 'arrow']
                //     },
                //     axisLabel:{
                //         inside: false,
                //     },
                //     boundaryGap: true,
                //     axisTick: { 
                //         alignWithLabel:true,
                //     }
                // },
                // {
                //     // name:'round',
                //     offset:-690,
                //     data:bottomTime,
                //     axisLine:{
                //         show: true,
                //         symbol: ['none', 'arrow']
                //     },
                //     axisLabel:{
                //         inside: true,
                //     },
                //     boundaryGap: true,
                //     axisTick: { 
                //         alignWithLabel:true,
                //     }
                // }
            ],
            yAxis: {
                type: 'category',
                name:'validator',
                data: this.state.AxisY,
                triggerEvent: true,
                axisLabel:{
                    margin:8,
                    formatter:function(data){ 
                        var val=''
                        if(data.length>4){
                            val = data.substr(0,4)+'...';
                            return val ;
                        }else {
                            return data;
                        }
                    }
                },
                boundaryGap: false,
                // min: 0,
                // max: 5,
                // scale: true,
                axisTick: {
                    alignWithLabel: true
                }
                
            },
            toolbox: {
                feature: {
                    dataZoom: {}
                }
            },
            // dataZoom: {
            //     type: 'inside'
            // },
            series: series,
        }; 
        myChart.setOption(option);

        extension(myChart);
        function extension(myChart){
            var elementDiv = document.getElementById('extension');
            if(!elementDiv){
                var div = document.createElement('div')
                div.setAttribute('id', 'extension')
                div.style.display = 'block'
                document.querySelector('html').appendChild(div)
            }
            myChart.on('mouseover',function(params){
                if (params.componentType == 'yAxis') {
                    var elementDiv = document.querySelector('#extension')
                    var elementStyle =
                      'position: absolute;margin-left:35px;z-index: 99999;color: #fff;font-size: 12px;padding: 5px;display: inline;border-radius: 4px;background-color: #303133;box-shadow: rgba(0, 0, 0, 0.3) 2px 2px 8px'
                    elementDiv.style.cssText = elementStyle
                    elementDiv.innerHTML = params.value
                    document.querySelector('html').onmousemove = function (event) {
                      var elementDiv = document.querySelector('#extension')
                      var xx = event.pageX - 10
                      var yy = event.pageY + 15
                      elementDiv.style.top = yy + 'px'
                      elementDiv.style.left = xx + 'px'
                    }
                  }
            })
            myChart.on('mouseout', function (params) {
                if (params.componentType == 'yAxis') {
                  var elementDiv = document.querySelector('#extension')
                  elementDiv.style.cssText = 'display:none'
                }
            })
        }
    })
  }
  render() {
    return (
        <div id="main" className="container" style={{ padding: '50px', boxSizing:'border-box',  width: '100%', height: 1000 }}> 
        </div>
    );
  }
}
export default App;
